package com.test.ejb;


import java.util.HashMap;
import java.util.Map;

import javax.ejb.embeddable.EJBContainer;
import javax.naming.NamingException;

import org.testng.Assert;
import org.testng.annotations.AfterClass;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;


public class TestEJBTest {

    private EJBContainer container;

    @BeforeClass
    public void deploy() {
        Map<String, Object> parameters = new HashMap<String, Object>();
        parameters.put("org.glassfish.ejb.embedded.glassfish.installation.root", "target/glassfish");
        parameters.put("javax.ejb.embeddable.modules", new String[] { "classes", "dummy" });
        parameters.put("javax.ejb.embeddable.appName", "TEST");
        // this doesn't work
        parameters.put("glassfish.embedded.tmpdir", "target");
        // neither does this
        parameters.put("org.glassfish.ejb.embedded.keep-temporary-files", true);
        container = EJBContainer.createEJBContainer(parameters);
    }

    @AfterClass
    public void shutdown() {
        if (container != null) {
            container.close();
        }
    }

    @Test
    public void test() throws NamingException {
        TestEJB ejb = (TestEJB) container.getContext().lookup("java:global/TEST/classes/TestEJB");
        Assert.assertNotNull(ejb);
        System.out.println(ejb.method());
    }
}
