package com.test.jpa;


import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToOne;
import javax.persistence.TableGenerator;


@Entity
public class Person {

    @Id
    @TableGenerator(
            name = "PersonSequence",
            table = "Sequence",
            pkColumnName = "tableName",
            valueColumnName = "lastValue",
            pkColumnValue = "Person",
            allocationSize = 10)
    @GeneratedValue(strategy = GenerationType.TABLE, generator = "PersonSequence")
    private Long id;

    private String name;

    private String lastName;

    @OneToOne(optional = true, cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    private Phone phone;

    public Person() {
        //
    }

    public Person(String name, String lastName) {
        this.name = name;
        this.lastName = lastName;
    }

    public Long getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public String getLastName() {
        return lastName;
    }

    public Phone getPhone() {
        return phone;
    }

    public void setPhone(Phone phone) {
        this.phone = phone;
    }

    @Override
    public String toString() {
        return name + " " + lastName + "; " + (phone != null ? phone : "no phone");
    }
}
