package com.test.jpa;


import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.TableGenerator;


@Entity
public class Phone {

    @Id
    @TableGenerator(
            name = "PhoneSequence",
            table = "Sequence",
            pkColumnName = "tableName",
            valueColumnName = "lastValue",
            pkColumnValue = "Phone",
            allocationSize = 10)
    @GeneratedValue(strategy = GenerationType.TABLE, generator = "PhoneSequence")
    private Long id;

    private String number;

    public Phone() {
        //
    }

    public Phone(String number) {
        this.number = number;
    }

    public Long getId() {
        return id;
    }

    public String getNumber() {
        return number;
    }

    @Override
    public String toString() {
        return number;
    }
}
